/* myR - A C++ library for accessing R
 *
 * (C) 2004 Pedro Ribeiro de Andrade Neto
 * pedrorib@yahoo.com
 */

#ifndef MYR_H_
#define MYR_H_

#define USE_RINTERNALS

extern "C"
{


//namespace myRnamespace
//{
	
#include <R.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "Parse.h"

// for windows, that don't have some functions implemented in the dll...
//#include "winembed.c"

#ifndef real
#define real double
#endif

enum myError
{
    myOK,
    myERROR_PARSING,
    myERROR_EVALUATING
};

class myR
{
    public:
        myR();
        myR(int argc, char** argv);

        myError Execute (const char* command, SEXP& result);
        void DeclareVar (const char* name, SEXP var);
        void DeleteVar  (SEXP var);

        void printSEXP(SEXP e);
	void myCallBack();
    private:
        #define dumpLimit 128
        
	SEXP parseString(const char *s, int *parts, ParseStatus *status);
        SEXP evaluate(SEXP ps, int& Rerror);
};

//}

}

#endif
