/* Sample of using myR
 *
 * (C) 2004 Pedro Ribeiro de Andrade Neto
 * pedrorib@yahoo.com
 */

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <setjmp.h>
#include <signal.h>

#include "myR.h"

extern "C"
{
void run_Rmainloop(void);
void end_Rmainloop(void);
struct IoBuffer;
extern int R_IoBufferInit(void*);
extern IoBuffer* R_ConsoleIob; 
#define SETJMP(x) sigsetjmp(x,0)

#define JMP_BUF sigjmp_buf

typedef struct RCNTXT {
    struct RCNTXT *nextcontext; /* The next context up the chain */
    int callflag;               /* The context "type" */
    JMP_BUF cjmpbuf;            /* C stack and register information */
    int cstacktop;              /* Top of the pointer protection stack */
    int evaldepth;              /* evaluation depth at inception */
    SEXP promargs;              /* Promises supplied to closure */
    SEXP callfun;               /* The closure called */
    SEXP sysparent;             /* environment the closure was called from */
    SEXP call;                  /* The call that effected this context*/
    SEXP cloenv;                /* The environment */
    SEXP conexit;               /* Interpreted "on.exit" code */
    void (*cend)(void *);       /* C "on.exit" thunk */
    void *cenddata;             /* data for C "on.exit" thunk */
    char *vmax;                 /* top of R_alloc stack */
    int intsusp;                /* interrupts enables */
#ifdef NEW_CONDITION_HANDLING
    SEXP handlerstack;          /* condition handler stack */
    SEXP restartstack;          /* stack of available restarts */
#endif
#ifdef BYTECODE
    SEXP *nodestack;
# ifdef BC_INT_STACK
    IStackval *intstack;
# endif
#endif
} RCNTXT, *context;

extern RCNTXT R_Toplevel;
extern RCNTXT* R_GlobalContext;
extern RCNTXT* R_ToplevelContext;
//static void R_ReplConsole(SEXP, int, int);

using namespace std;
//using namespace myRnamespace;

int main()
{
    char* texto;
    char* argv[] = {"Rterm", "--silent","--vanilla"};
    SEXP exp;
    myError error;
    myR myr(3, argv);

    texto = new char[200];
  /*
    R_IoBufferInit(&R_ConsoleIob);
    SETJMP(R_Toplevel.cjmpbuf);
    R_GlobalContext = R_ToplevelContext = &R_Toplevel;
#ifdef REINSTALL_SIGNAL_HANDLERS
    signal(SIGINT, handleInterrupt);
    signal(SIGUSR1,onsigusr1);
    signal(SIGUSR2,onsigusr2);
#ifdef Unix
    signal(SIGPIPE, onpipe);
#endif
#endif
  //  R_ReplConsole(R_GlobalEnv, 0, 0);
//    end_Rmainloop(); /* must go here */
	    
   
    run_Rmainloop();

    while(1)
    {
        printf("\n>");
        scanf ("%s", texto);

        error = myr.Execute(texto, exp);

        switch(error)
        {
            case myOK:
                if(exp) myr.printSEXP(exp);
                break;
            case myERROR_PARSING:
                printf("parsing error\n");
                break;
            case myERROR_EVALUATING:
                printf("evaluating error\n");
                break;
        }
    }

  return 0;
}
}

